function I0=DrainCurrent1(Ip,IDQ,VDS,N)
% this function finds the DC current

V=abs(VDS);
phi=pi-angle(VDS);
alpha2=acos(-IDQ/(Ip-IDQ));
k0=1-(V/2).^N*nchoosek(N,N/2);
k2R=-2*(V/2).^N*nchoosek(N,N/2-1).*cos(2*phi);
% k2Q=2*(V/2).^N*nchoosek(N,N/2-1).*sin(2*phi);

if and((2*IDQ<Ip),(Ip>0))

    j=2:N+1;
    A0=IDQ/pi*(alpha2-sin(alpha2)/cos(alpha2));
    A1=2/pi*(IDQ*sin(alpha2) - ((IDQ*alpha2)/2 + (IDQ*sin(2*alpha2))/4)/cos(alpha2));
    Aj=2/pi*((IDQ*sin(j*alpha2))./j - ((IDQ*sin((j-1)*alpha2))./((j-1)*2)+(IDQ*sin((j+1)*alpha2))./((j+1)*2))/cos(alpha2));
    Aj=[A1 Aj];
    
    for n=2:N/2-1
        k2Rn=-2*(V/2).^N*nchoosek(N,N/2-n).*cos(2*n*phi);
%         k2Qn=2*(V/2).^N*nchoosek(N,N/2-n).*sin(2*n*phi);
        k2R=[k2R k2Rn];
%         k2Q=[k2Q k2Qn];
    end
    k2R=[k2R -2*(V/2).^N.*cos(2*N/2*phi)];
%     k2Q=[k2Q 2*(V/2).^N.*sin(2*N/2*phi)];
    
    
    I0=A0*k0+1/2*Aj(2:2:N)*k2R';
%     I1R=A1*k0+1/2*(Aj(1:2:N-1)+Aj(3:2:N+1))*k2R';
%     I1Q=1/2*(Aj(1:2:N-1)-Aj(3:2:N+1))*k2Q';
    
else
    if Ip<0
        I0=0;
    else
        A0=IDQ;
    
%     A1=Ip-IDQ;
        I0=A0*k0;
    end
%     I1R=A1*k0+1/2*A1*k2R;
%     I1Q=1/2*A1*k2Q;
end

% IDS=I1R+1i*I1Q;
% VDS=V*(-cos(phi)+1i*sin(phi));

end