function I0=DrainCurrent1m(Ip,IDQ,VDS,N,nchk)
% this function finds the DC current

V=abs(VDS);
phi=pi-angle(VDS);
alpha2=acos(-IDQ/(Ip-IDQ));
n=1:(N+1)/2;
k0=1;
k1R=2*(V/2)^N*nchk(n).*cos((2*n-1)*phi);



if and((2*IDQ<Ip),(Ip>0))

    j=2:N+1;
    A0=IDQ/pi*(alpha2-sin(alpha2)/cos(alpha2));
    A1=2/pi*(IDQ*sin(alpha2) - ((IDQ*alpha2)/2 + (IDQ*sin(2*alpha2))/4)/cos(alpha2));
    Aj=2/pi*((IDQ*sin(j*alpha2))./j - ((IDQ*sin((j-1)*alpha2))./((j-1)*2)+(IDQ*sin((j+1)*alpha2))./((j+1)*2))/cos(alpha2));
    Aj=[A1 Aj];
    
%      for n=2:N/2-1
%          k1Rn=-2*(V/2).^N*nchoosek(N,N/2-n).*cos(2*n*phi);
%          k1R=[k1R k1Rn];
%      end
%      k1R=[k1R -2*(V/2).^N.*cos(2*N/2*phi)];
%    
    
    I0=k0*A0+1/2*Aj(1:2:N)*k1R';
    
else
    if Ip<0
        I0=0;
    else
        A0=IDQ;
    
        I0=k0*A0+A1*k1R(1); % bu kismi duzeltilmedi
    end
end


end